<?php
class api4marketing {

    private $server;
    private $apiKey;
    private $sessionID;
    private $status;
    private $response;

    public function __construct($server,$apiKey) {

        $this->server       = $server;
        $this->apiKey       = $apiKey;

        $this->status       = false;
        $this->token        = false;

        $this->login();
    }

    private function call($data = array(), $command = "",$method = 1,$test=0) {


        //$argString = implode('&',$data);

       // echo "<pre>";
        //var_dump($argString);
        $defaults = array(
            CURLOPT_HEADER => 0,
            CURLOPT_POST => $method == 1 || $method == 2 ? true : false,
            CURLOPT_HTTPHEADER =>array('Content-Type: application/json'),
            CURLOPT_URL => Configuration::get("4DEM_CONSOLE_URL")."/".$command.($this->token!=false ? "?token=".$this->token : ""),
            CURLOPT_RETURNTRANSFER => 1
        );
        if($method==1) {
            $defaults[CURLOPT_POSTFIELDS] = json_encode($data);
        }else if($method==2) {
            $defaults[CURLOPT_POSTFIELDS] = json_encode($data);
            $defaults[CURLOPT_HEADER] = true;
            $defaults[CURLOPT_CUSTOMREQUEST] = "PUT";
        }

        $ch = curl_init();
        curl_setopt_array($ch, $defaults);

        $response = curl_exec($ch);
        if($test==1) {
            echo "<pre>";
            var_dump($response);
            echo "</pre>";

        } else if($test==2) {
            echo "<pre>";
            var_dump($defaults);
            echo "</pre>";

        }
        $response = json_decode($response);


        return $response;
    }
    

    public function downloadReport($id_import){
        $command = "imports/".$id_import."/download-report";
        $fh = fopen(dirname(__FILE__)."/s2s/imports/report_$id_import.csv", "w");
        //$argString = implode('&',$data);
        $defaults = array(
            CURLOPT_HEADER => 0,
            CURLOPT_HTTPHEADER => array('Content-Type: application/json'),
            CURLOPT_URL => $this->server . "/" . $command . ($this->token != false ? "?token=" . $this->token : ""),
            CURLOPT_RETURNTRANSFER => 1,
            CURLOPT_FILE => $fh
        );
        $ch = curl_init();
        curl_setopt_array($ch, $defaults);
        curl_exec($ch);
        curl_close($ch);
        
    }
    /**
     * Crea un array di corrispondenza per i campi personalizzati
     *
     * @return array
     */
   public function createFields()
    {
        $fields = array();

        // Campi Single Line

        $field["name"] = "Email";
        $field["type"] = "Email";
        $field["default_value"] = "";
        $field["validation"]["unique"] = true;
        $field["visibility"] = "Public";
        $field["val"] = "NULL";
        $fields["email"] = $field;

        $field["validation"]["unique"] = false;
        $field["name"] = "Mobile";
        $field["type"] = "Mobile";
        $fields["mobile"] = $field;

        $field["name"] = "Nome";
        $field["type"] = "Single line";
        $fields["name"] = $field;

        $field["name"] = "Cognome";
        $fields["surname"] = $field;

        $field["name"] = "Sesso";
        $fields["sex"] = $field;

        $field["name"] = "Lingua";
        $fields["language"] = $field;


        $field["name"] = "Guest";
        $fields["is_guest"] = $field;

        $field["name"] = "Paese";
        $fields["country"] = $field;

        $field["name"] = "Provincia";
        $fields["province"] = $field;

        $field["name"] = "Citta";
        $fields["city"] = $field;

        $field["name"] = "Sorgente";
        $fields["source"] = $field;


        //Campi Data

        $field["name"] = "Data registrazione al sito";
        $field["type"] = "Date field";
        $fields["reg_date"] = $field;

        $field["name"] = "Data di nascita";
        $fields["birth_date"] = $field;

        $field["name"] = "Data iscrizione Newsletter";
        $fields["news_date"] = $field;

        $field["name"] = "Gruppo";
        $field["type"] = "Checkboxes";
        $field["options"] = array();
        foreach (Group::getGroups(Context::getContext()->language->id) as $key => $gruppo) {
            $opt = array();
            $opt["label"] = $gruppo["name"];
            $opt["value"] = $gruppo["id_group"];
            $opt["selected"] = false;
            $field["options"][] = $opt;
        }
        $fields["group"] = $field;
        return $fields;
    }
    /**
     * Invio massivo di dati a 4Dem
     *
     * @param $callback
     * @param $operations
     * @return mixed
     */
    public function runImport($id_import = 0)
    {
        $command = "imports/".$id_import."/start";
        $response = $this->call(array(), $command, 0,0);
        if ($response) {
            if (isset($response->data)) {
                return $response->data;
            }
        }
        return false;
    }

    /**
     * Invio massivo di dati a 4Dem
     *
     * @param $callback
     * @param $operations
     * @return mixed
     */
    public function importRecipient($callback, $status = "Subscribed")
    {
        $commands = "imports";
        //$mappedFields = json_encode($mappedFields);

        $args = array();
        $args["skip_error"] = true;
        
        $args["import_strategy"] = "url";

        $args["entity_type"] = "recipient";
        $args["settings"]["update_if_duplicate"] = true;
        $args["settings"]["subscriber_status"] = $status;
        $args["settings"]["triggers"] = array(
            "automation" => true,
            "behaviors" => true,
            "send_confirmation_email" => true
        );
        $args["callback_url"] = $callback;

        $args["entity_id"] = Configuration::get('4DEM_SELECTED_LIST_ID');
        
        $args["import_strategy_settings"] = [];
        $args["import_strategy_settings"]["url"] = Tools::getCurrentUrlProtocolPrefix() . Tools::getHttpHost() . "/modules/blockfourdem_pshop/json/" . ($status == "Subscribed" ? "json.json" : "json_unsub.json" )."?".rand();
        $args["import_strategy_settings"]["is_paginated"] = false;
        $args["import_strategy_settings"]["timeout"] = 10000;
        $args["import_strategy_settings"]["page_value"] = 1;
        $args["import_strategy_settings"]["page_key"] = "page";
        $args["import_strategy_settings"]["limit_value"] = 15;
        $args["import_strategy_settings"]["limit_key"] = "limit";
        $args["import_strategy_settings"]["response_page_key"] = "meta.current_page";
        $args["import_strategy_settings"]["response_total_page_key"] = "meta.total_pages";
        $args["import_strategy_settings"]["response_total_page_value"] = 1;
        $mappedFields = array();
        foreach(json_decode(Configuration::get("4DEM_CUSTOM_FIELDS"),true) as $field){
            $mappedFields[$field["id"]] = $field["name"];
        }
        $args["mapped_fields"] = $mappedFields;

        $response = $this->call($args, $commands, 1);
        if(is_numeric($response)){
            return $this->runImport($response);
        }

        return $response;
    }

    public function createWebServiceUnsubscribe($callback) {
        $commands="web_services";
        $args = array();
        $args["recipient_id"] = Configuration::get('4DEM_SELECTED_LIST_ID');
        $args["type"] = "unsubscription";
        $args["url"] = $callback;
        $response = $this->call($args,$commands,1);
        $this->response = $response;

        if (is_numeric($response)) {
            return $response;
        }
        return false;
    }
    public function login() {

        $login = array();
        $login[] =

        $command= "authenticate";
        $defaults = array(
            CURLOPT_POST => 1,
            CURLOPT_HEADER => 0,
            CURLOPT_URL => Configuration::get("4DEM_CONSOLE_URL")."/authenticate",
            CURLOPT_USERAGENT => '4marketing',
            CURLOPT_FRESH_CONNECT => 0,
            CURLOPT_RETURNTRANSFER => 1,
            CURLOPT_FORBID_REUSE => 0,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_SSL_VERIFYPEER => 0,
            CURLOPT_SSL_VERIFYHOST => 0,
            CURLOPT_POSTFIELDS => "APIKey=".$this->apiKey
        );
        $ch = curl_init();
        curl_setopt_array($ch, $defaults);

        $response = curl_exec($ch);

        $response = json_decode($response);
        $this->response = $response;

        if (isset($response) && isset($response->token)) {
            $this->status = true;
            $this->token = $response->token;
        }else{
            $this->status = false;
        }
        return $this->status;

    }

    public function getLists() {

        $commands="recipients";
        $response = $this->call(array(),$commands,0);

        $this->response = $response;
        if ($response) {
            if (isset($response->data)) {
                return $response->data;
            }
        }
        return false;
    }

    public function massiveImport($callback,$operations) {
        $commands="batches";

        $args = array();
        $args["callback_url"] = $callback;
        $args["skip_error"] = true;
        $args["operations"] = $operations;

        $response = $this->call($args,$commands,1);
        $this->response = $response;
        if (isset($response->id)) {
            return $response->id;
        }
        return false;
    }
    public function updList($listId){

        $command="recipients/".$listId;
        $params = array();
        $params["name"] = Context::getContext()->shop->domain." - ".Context::getContext()->shop->name." ID: ".Context::getContext()->shop->id;

        $integration = array();
        $integration["active"] = true;
        $integration["domain"] = Context::getContext()->shop->domain;
        $integration["shopid"] = Context::getContext()->shop->id;
        $integration["module"] = "prestashop";
        $integration["last_sync_date"] = (Configuration::get('4DEM_LAST_SYNC') ? strtotime(Configuration::get('4DEM_LAST_SYNC')) : 0);

        $params["integration"]=$integration;

        $response = $this->call($params,$command,2);
        $this->response = $response;
        if ($response) {
            return false;
        }
        return true;
    }
    public function createList() {

        $command = "recipients";
        $params = array();
        $params["name"] = Context::getContext()->shop->domain . " - " . Context::getContext()->shop->name . " ID: " . Context::getContext()->shop->id;
        $params["opt_in"]["mode"] = "single";
        $params["opt_out"]["mode"] = "direct";
        $params["opt_out"]["add_to_global_suppression"] = false;
        $params["opt_out"]["add_to_local_suppression"] = false;

        $integration = array();
        $integration["active"] = true;
        $integration["domain"] = Context::getContext()->shop->domain;
        $integration["shopid"] = Context::getContext()->shop->id;
        $integration["module"] = "prestashop";
        // $integration["last_sync_date"] = date("Y-m-d h:i:s");

        $params["integration"] = $integration;
        $params["description_fields"] = array();
        $params["description_fields"]["origin"] = "Created by 4Dem module from ".Context::getContext()->shop->domain;
        $params["description_fields"]["refer"] = "4Dem Prestashop Module";
        $params["description_fields"]["short_description"] = "List created by 4Dem Prestashop Module";
        $params["custom_fields"] = $this->createFields();
        Configuration::updateValue('4DEM_CREATION_CMD', json_encode($params));
        $response = $this->call($params, $command);
        $this->response = $response;
        if (is_numeric($response)) {
            Configuration::updateValue('4DEM_SELECTED_LIST_ID', $response);
            return true;
        }

        return (isset($response->status_code) ? $response->status_code . ": " : "") . json_encode($response->message);
    }

     public function createCustomFields($listId, $fields, $callback)
    {
        $command = "batches";

        /*CREAZIONE SCHEMA CAMPI CUSTOM*/
        $json = array();
        $operations = array();
        // $fields = $this->createFieds();
        foreach ($fields as $key => $field) {
            $customField = array();
            $customField["recipient_id"] = $listId;
            $customField["name"] = $field["name"];
            $customField["type"] = $field["type"];
            $customField["global"] = false;
            if ($field["type"] == "Checkboxes") {
                $options = array();
                foreach ($field["options"] as $key2 => $opt) {
                    $options[$key2]["label"] = $opt["label"];
                    $options[$key2]["value"] = $opt["val"];
                    $options[$key2]["selected"] = false;

                }
                $customField["options"] = $options;
            }
            if ($field["type"] == "Date field") {
                $customField["year"]["from"] = 1980;
                $customField["year"]["to"] = 2050;
            }
            $customField["default_value"] = $field["val"];
            $operations[] = array("command" => "CustomField.Store", "custom_id" => $key, "body" => $customField);

            //$response = $this->call($customField,$command);
            $json[$key]["ignore"] = false;
            $json[$key]["name"] = $field["name"];
            $json[$key]["id"] = false;

        }
        $batch = array("callback_url" => $callback, "skip_error" => false, "operations" => $operations);

        Configuration::updateValue('4DEM_CREATE_FIELD_CMD', json_encode($batch));
        $response = $this->call($batch, $command, 1);
        Configuration::updateValue('4DEM_CREATE_FIELD', json_encode($response));
        // Configuration::updateValue("4DEM_CUSTOM_FIELDS_WAITING",1);
        if (is_numeric($response)) {
            Configuration::updateValue('4DEM_CUSTOM_FIELDS', json_encode($json));
            return true;
        }
        return false;
    }
    public function updateCustomField($listId,$field,$fieldID) {
        /*CREAZIONE SCHEMA CAMPI CUSTOM*/
        $command = "custom_fields/".$fieldID;
        $args = array();
        $args["recipient_id"] = $listId;
        $args["name"] = $field["name"];
        $args["type"] = $field["type"];
        if($field["type"] == "Checkboxes"){
            $options = array();
            foreach($field["options"] as $key2 => $opt){
                $options[$key2]["label"] = $opt["label"];
                $options[$key2]["value"] = $opt["val"];
                $options[$key2]["selected"] = false;

            }
            $args["options"] = $options;
        }
        $response = $this->call($args,$command,2,2);
        ddd($response);
        if(!$response->Success) {
            $err = "Errore per ".$key2;
        }

        if ($err=="") {
            return true;
        }
        return $err;
    }

    public function getCustomFields($listId) {

        $command = "recipients/".$listId."/custom_fields";
        $response = $this->call(array(),$command,0);

        $this->response = $response;
        if ($response) {
            if (isset($response->data)) {
                return $response->data;
            }
        }
        return false;
    }

    public function subscribe($listId,$email,$mobile = "",$customFields = false, $customerInfo = false) {

        $command="recipients/".$listId."/subscribe";

        $subscribe = array();
        $subscribe["update_if_duplicate"] = true;
        $subscribe["email_address"] = $email;
        if($mobile!="")
            $subscribe["mobile"] = urldecode($mobile);

       if ($customFields) {
           $subscribe["custom_fields"] = array();
            foreach ($customFields as $key => $field) {
                $subscribe["custom_fields"][$key]["id"] = $field;
                $subscribe["custom_fields"][$key]["value"] = $customerInfo[$key];
            }
        }
        $subscribe["subscription"]["ip"] = Tools::getRemoteAddr();

        $response = $this->call($subscribe,$command);
        $this->response = $response;

//customump($response);die();
        if ($response && is_numeric($response)) {
            return $response;

        }
        return false;
    }

    public function getSubscriber($listId,$id) {

        $command = "recipients/".$listId."/contacts/".$id;

        $response = $this->call(array(),$command,0);
        $this->response = $response;

        if ($response) {
            if (isset($response->data)) {
                return $response->data;
            }
        }
        return false;
    }


    public function getSubscribersNumber($listId) {
        $command = "recipients/".$listId."/contacts";

        $response = $this->call(array(),$command,0);
        $this->response = $response;
        if ($response) {
            if (isset($response->meta)) {
                return $response->meta->pagination->total;
            }
        }
        return false;
    }



    /**
     * Cancella un utente dalla newsletter
     *
     * @param $listId
     * @param $id
     * @return bool
     */
    public function unsubscribe($listId, $id)
    {
        $command = "recipients/" . $listId . "/contacts/" . $id . "/change-status";
        $args = array();
        $args["status"] = "Unsubscribed";
        $args["ip"] = (isset($_SERVER['REMOTE_ADDR'])) ? $_SERVER['REMOTE_ADDR'] : '0.0.0.0';
        $args["triggers"] = array(
            "automation" => false,
            "behaviors" => false,
            "send_confirmation_email" => false
        );

        $response = $this->call($args, $command);
        $this->response = $response;
        if ($response) {
            if ($response->Success == true) {
                return true;
            }
        }
        return false;
    }
     public function updateList($listId)
    {
        $command = "recipients/" . $listId;
        $params = array();
        $params["name"] = Configuration::get('4DEM_SELECTED_LIST_NAME');
        $params["opt_in"]["mode"] = "single";
        $params["opt_out"]["mode"] = "direct";
        $params["opt_out"]["add_to_global_suppression"] = false;
        $params["opt_out"]["add_to_local_suppression"] = false;
        $integration = array();
        $integration["active"] = true;
        $integration["domain"] = Context::getContext()->shop->domain;
        $integration["shopid"] = Context::getContext()->shop->id;
        $integration["module"] = "prestashop";
        $integration["last_sync_date"] = (Configuration::get('4DEM_LAST_SYNC_CONTACTS') ? (Configuration::get('4DEM_LAST_SYNC_CONTACTS')) : 0);

        $params["integration"] = $integration;
        Configuration::updateValue('4DEM_CMD_UPT', json_encode($params));

        $response = $this->call($params, $command, 2);

        $this->response = $response;
        Configuration::updateValue('4DEM_CMD_UPT_RES', json_encode($response));
        if (is_null($response)) {
            return true;
        }

        return false;
    }
    /**
     * Verifica congruenza dei campi personalizzati
     *
     * @param $listId
     * @param $fields
     * @return bool
     */
    public function checkCustomFields($listId, $fields)
    {   

        // Campi su 4dem
        $DemFields = $this->getCustomFields($listId);
        if (is_null($DemFields)) {
            return false;
        } elseif ((sizeof($DemFields) < sizeof($fields))) {
            // dump($DemFields);
            // dump($fields);

            // die();
            return 0;
        } else {
            foreach ($fields as $key => $value) {
                $found = false;
                foreach ($DemFields as $demField) {
                    if ($fields[$key]['name'] == $demField->name) {
                        $fields[$key]['id'] = $demField->id;
                        $found = true;
                        break;
                    }
                }
                if (!$found) {


                    return false;
                }
            }
        }
        $json = array();
        foreach ($fields as $key => $field) {
            $json[$key]["ignore"] = false;
            $json[$key]["name"] = $field["name"];
            $json[$key]["id"] = $field["id"];

        }

        Configuration::updateValue('4DEM_CUSTOM_FIELDS', json_encode($json));
        return true;
    }


    public function checkList($listId)
    {
        $command = "recipients/" . $listId;

        $response = $this->call(array(), $command, 0);

        $this->response = $response;

        if ($response) {
            if (isset($response->data)) {
                Configuration::updateValue('4DEM_SELECTED_LIST_ID', $response->data->id);
                Configuration::updateValue('4DEM_SELECTED_LIST_NAME', $response->data->name);
                return true;
            }
        }
        return false;
    }

    public function getUnsubscribed($listId) {

        $subscriberGet = array();
        $subscriberGet[] = "SessionID=".$this->sessionID;
        $subscriberGet[] = "Command=Subscribers.Get";
        $subscriberGet[] = "ResponseFormat=JSON";
        $subscriberGet[] = "OrderField=UnsubscriptionDate";
        $subscriberGet[] = "OrderType=ASC";
        $subscriberGet[] = "RecordsFrom=0";
        $subscriberGet[] = "SubscriberListID=".$listId;
        $subscriberGet[] = "SubscriberSegment=Unsubscribed";

        $response = $this->call($subscriberGet);
        $this->response = $response;
//var_dump($response);die();
        if ($response) {
            if ($response->Success == true) {
                return $response->Subscribers;
            }
        }
        return false;
    }

    public function getStatus() {
        return $this->status;
    }

    public function getResponse()
    {
        return $this->response;
    }
}
?>